Index: orxonox/branches/levelloader/src/world_entities/weapon.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/weapon.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/weapon.cc	(revision 3746)
@@ -21,6 +21,8 @@
 #include "world_entity.h"
 #include "vector.h"
-#include "objModel.h"
+#include "model.h"
 #include "projectile.h"
+#include "list.h"
+#include "world.h"
 
 using namespace std;
@@ -32,6 +34,13 @@
    creates a new weapon
 */
-Weapon::Weapon () : WorldEntity()
-{}
+Weapon::Weapon (PNode* parent, Vector* coordinate, Quaternion* direction) 
+  : WorldEntity()
+{
+  parent->addChild(this, PNODE_ROTATE_AND_MOVE);
+  this->setRelCoor(coordinate);
+  this->setRelDir(direction);
+  WorldInterface* wi = WorldInterface::getInstance();
+  this->worldEntities = wi->getEntityList();
+}
 
 
@@ -145,5 +154,7 @@
 */
 void Weapon::setWeaponIdleTime(float time)
-{}
+{
+  this->idleTime = time;
+}
 
 /**
@@ -155,5 +166,7 @@
 */
 float Weapon::getWeaponIdleTime(void)
-{}
+{
+  return this->idleTime;
+}
 
 /**
@@ -165,5 +178,7 @@
 */
 bool Weapon::hasWeaponIdleTimeElapsed(void)
-{}
+{
+  return (this->localTime>this->idleTime)?true:false;
+}
 
 
Index: orxonox/branches/levelloader/src/world_entities/weapon.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/weapon.h	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/weapon.h	(revision 3746)
@@ -43,5 +43,5 @@
 
  public:
-  Weapon ();
+  Weapon (PNode* parent, Vector* coordinate, Quaternion* direction);
   virtual ~Weapon ();
   
@@ -57,9 +57,9 @@
   bool isActive(void);
 
-  virtual void setWeaponIdleTime(float time);
-  virtual float getWeaponIdleTime(void);
-  virtual bool hasWeaponIdleTimeElapsed(void);
+  void setWeaponIdleTime(float time);
+  float getWeaponIdleTime(void);
+  bool hasWeaponIdleTimeElapsed(void);
 
-  virtual void fire(void);
+  virtual void fire(void) = 0;
   virtual void hit (WorldEntity* weapon, Vector* loc);
   virtual void destroy(void);
@@ -69,12 +69,14 @@
   virtual void draw(void);
 
+ protected:
+  tList<WorldEntity>* worldEntities;
+  float localTime;
+  float idleTime;
+  float slowDownFactor;
 
  private:
   bool enabled;
-  float localTime;
-  float slowDownFactor;
   Projectile* projectile;
   //WeaponSound sound;
-
 };
 
Index: orxonox/branches/levelloader/src/world_entities/world_entity.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/world_entity.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/world_entity.cc	(revision 3746)
@@ -19,5 +19,8 @@
 
 #include "world_entity.h"
-#include "stdincl.h"
+#include "objModel.h"
+#include "list.h"
+
+//#include "stdincl.h"
 //#include "collision.h"
 
@@ -48,5 +51,6 @@
 {
   // if( collisioncluster != NULL) delete collisioncluster;
-  delete this->model;
+  if (this->model)
+    ResourceManager::getInstance()->unload(this->model);
 }
 
@@ -167,5 +171,5 @@
    Handle all stuff that should update with time inside this method (movement, animation, etc.)
 */
-void WorldEntity::tick(float time) 
+inline void WorldEntity::tick(float time) 
 {
 }
@@ -177,5 +181,5 @@
    This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
 */
-void WorldEntity::draw() 
+inline void WorldEntity::draw() 
 {}
 
Index: orxonox/branches/levelloader/src/world_entities/world_entity.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/world_entity.h	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/world_entity.h	(revision 3746)
@@ -7,10 +7,12 @@
 #define _WORLD_ENTITY_H
 
-#include "stdincl.h"
 #include "p_node.h"
-#include "objModel.h"
+#include "comincl.h"
+#include "resource_manager.h"
+
 
 //class CollisionCluster;
 class CharacterAttributes;
+class Model;
 
 
@@ -48,5 +50,5 @@
   
  protected:
-  OBJModel* model;                  //!< The model that should be loaded for this entity.
+  Model* model;                  //!< The model that should be loaded for this entity.
   CharacterAttributes* charAttr;      //!< the character attributes of a world_entity
   
